package com.sun.xml.internal.messaging.saaj.soap;

import java.awt.Image;
import java.io.OutputStream;
import java.io.InputStream;
import java.awt.Toolkit;
import java.io.IOException;
import javax.activation.DataSource;
import java.awt.datatransfer.DataFlavor;
import javax.activation.ActivationDataFlavor;
import javax.activation.DataContentHandler;
import java.awt.Component;

public class GifDataContentHandler extends Component implements DataContentHandler
{
    private static ActivationDataFlavor myDF;
    
    public GifDataContentHandler() {
    }
    
    protected ActivationDataFlavor getDF() {
        return GifDataContentHandler.myDF;
    }
    
    public DataFlavor[] getTransferDataFlavors() {
        return new DataFlavor[] { this.getDF() };
    }
    
    public Object getTransferData(DataFlavor df, DataSource ds) throws IOException {
        if (this.getDF().equals(df)) {
            return this.getContent(ds);
        }
        return null;
    }
    
    public Object getContent(DataSource ds) throws IOException {
        InputStream is = ds.getInputStream();
        int pos = 0;
        byte[] buf = new byte[1024];
        int count;
        while ((count = is.read(buf, pos, buf.length - pos)) != -1) {
            pos += count;
            if (pos < buf.length) {
                continue;
            }
            int size = buf.length;
            if (size < 262144) {
                size += size;
            }
            else {
                size += 262144;
            }
            byte[] tbuf = new byte[size];
            System.arraycopy(buf, 0, tbuf, 0, pos);
            buf = tbuf;
        }
        Toolkit tk = Toolkit.getDefaultToolkit();
        return tk.createImage(buf, 0, pos);
    }
    
    public void writeTo(Object obj, String type, OutputStream os) throws IOException {
        if (obj != null && !(obj instanceof Image)) {
            throw new IOException("\"" + this.getDF().getMimeType() + "\" DataContentHandler requires Image object, was given object of type " + obj.getClass().toString());
        }
        throw new IOException(this.getDF().getMimeType() + " encoding not supported");
    }
    
    static {
        GifDataContentHandler.myDF = new ActivationDataFlavor(Image.class, "image/gif", "GIF Image");
    }
}
